# save locations of any non-player entities for undo
# @s = puzzle block marker
# at @s
# run from mechanic/pusher/east
# run from mechanic/pusher/north
# run from mechanic/pusher/south
# run from mechanic/pusher/west
# run from mechanic/reset/puzzle

# save all block locations
execute as @e[type=marker,tag=gm4_pb_block] run data modify entity @s data.gm4_puzzle_block.saved_states append from entity @s Pos

# save piston state
execute as @e[type=item_display,tag=gm4_pb_piston] run data modify entity @s item.tag.gm4_puzzle_block.saved_states append from entity @s item.tag.gm4_puzzle_block.current_state

# save teleporter state
execute as @e[type=item_display,tag=gm4_pb_teleporter] run data modify entity @s item.tag.gm4_puzzle_block.saved_states append from entity @s item.tag.gm4_puzzle_block.current_state

# save magnet state (specific for swappable magnets)
execute as @e[type=slime,tag=gm4_pb_magnet.swappable] at @s run data modify entity @s ArmorItems[3].tag.gm4_puzzle_block.saved_states append from entity @s ArmorItems[3].tag.gm4_puzzle_block.current_state
