# update player inventory
# @s = player
# at @s
# run from technical/inventory/changed
# run from any in map_trigger/enter/
# run from activate/reset_blocks

tag @s add gm4_pb_changing_inv

# empty items to not show pop-in
loot replace entity @s inventory.7 loot gm4_puzzle_block:inventory/completion/empty
loot replace entity @s inventory.8 loot gm4_puzzle_block:inventory/completion/empty
loot replace entity @s inventory.13 loot gm4_puzzle_block:inventory/completion/empty
loot replace entity @s inventory.14 loot gm4_puzzle_block:inventory/completion/empty
loot replace entity @s inventory.15 loot gm4_puzzle_block:inventory/completion/empty
loot replace entity @s inventory.16 loot gm4_puzzle_block:inventory/completion/empty
loot replace entity @s inventory.17 loot gm4_puzzle_block:inventory/completion/empty

# stat box & spectator overlay
execute unless score $toggle.5 gm4_pb_completion matches 3 run item replace entity @s[tag=gm4_pb_pusher] armor.head with air
execute unless score $toggle.5 gm4_pb_completion matches 3 if score $intro_stage gm4_pb_data matches 2.. run loot replace entity @s[tag=!gm4_pb_pusher] armor.head loot gm4_puzzle_block:inventory/spectator_overlay
execute if score $toggle.5 gm4_pb_completion matches 3 run loot replace entity @s[tag=gm4_pb_pusher] armor.head loot gm4_puzzle_block:inventory/stat_hat
execute if score $toggle.5 gm4_pb_completion matches 3 run loot replace entity @s[tag=!gm4_pb_pusher] armor.head loot gm4_puzzle_block:inventory/spectator_stat_hat
execute unless score $toggle.5 gm4_pb_completion matches 3 run loot replace entity @s armor.chest loot gm4_puzzle_block:inventory/gm4_box_no_stat
execute if score $toggle.5 gm4_pb_completion matches 3 run loot replace entity @s armor.chest loot gm4_puzzle_block:inventory/gm4_box_with_stat

# completion title
loot replace entity @s inventory.13 loot gm4_puzzle_block:inventory/completion/title

# spring
scoreboard players operation $cmd gm4_pb_data = $completion.spring.puzzles gm4_pb_data
scoreboard players operation $cmd gm4_pb_data *= #10 gm4_pb_data
scoreboard players operation $cmd gm4_pb_data /= $spring.puzzles gm4_pb_data
execute if score $completion.spring.puzzles gm4_pb_data matches 1.. run scoreboard players operation $cmd gm4_pb_data > #1 gm4_pb_data
execute if score $spring.collectable gm4_pb_completion = $spring.collectable_count gm4_pb_data run scoreboard players add $cmd gm4_pb_data 50
execute store result storage gm4_puzzle_block:temp CustomModelData int 1 run scoreboard players add $cmd gm4_pb_data 100
loot replace entity @s inventory.17 loot gm4_puzzle_block:inventory/completion/lamps

# winter
scoreboard players operation $cmd gm4_pb_data = $completion.winter.puzzles gm4_pb_data
scoreboard players operation $cmd gm4_pb_data *= #10 gm4_pb_data
scoreboard players operation $cmd gm4_pb_data /= $winter.puzzles gm4_pb_data
execute if score $completion.winter.puzzles gm4_pb_data matches 1.. run scoreboard players operation $cmd gm4_pb_data > #1 gm4_pb_data
execute if score $winter.collectable gm4_pb_completion = $winter.collectable_count gm4_pb_data run scoreboard players add $cmd gm4_pb_data 50
execute store result storage gm4_puzzle_block:temp CustomModelData int 1 run scoreboard players add $cmd gm4_pb_data 200
loot replace entity @s inventory.16 loot gm4_puzzle_block:inventory/completion/lamps

# autumn
scoreboard players operation $cmd gm4_pb_data = $completion.autumn.puzzles gm4_pb_data
scoreboard players operation $cmd gm4_pb_data *= #10 gm4_pb_data
scoreboard players operation $cmd gm4_pb_data /= $autumn.puzzles gm4_pb_data
execute if score $completion.autumn.puzzles gm4_pb_data matches 1.. run scoreboard players operation $cmd gm4_pb_data > #1 gm4_pb_data
execute if score $autumn.collectable gm4_pb_completion = $autumn.collectable_count gm4_pb_data run scoreboard players add $cmd gm4_pb_data 50
execute store result storage gm4_puzzle_block:temp CustomModelData int 1 run scoreboard players add $cmd gm4_pb_data 300
loot replace entity @s inventory.15 loot gm4_puzzle_block:inventory/completion/lamps

# summer
scoreboard players operation $cmd gm4_pb_data = $completion.summer.puzzles gm4_pb_data
scoreboard players operation $cmd gm4_pb_data *= #10 gm4_pb_data
scoreboard players operation $cmd gm4_pb_data /= $summer.puzzles gm4_pb_data
execute if score $completion.summer.puzzles gm4_pb_data matches 1.. run scoreboard players operation $cmd gm4_pb_data > #1 gm4_pb_data
execute if score $summer.collectable gm4_pb_completion = $summer.collectable_count gm4_pb_data run scoreboard players add $cmd gm4_pb_data 50
execute store result storage gm4_puzzle_block:temp CustomModelData int 1 run scoreboard players add $cmd gm4_pb_data 400
loot replace entity @s inventory.14 loot gm4_puzzle_block:inventory/completion/lamps

# collectables
loot replace entity @s inventory.7 loot gm4_puzzle_block:inventory/completion/collectables
execute unless score $collectables gm4_pb_completion matches 1.. run loot replace entity @s inventory.8 loot gm4_puzzle_block:inventory/completion/collectables_0
execute if score $collectables gm4_pb_completion matches 1 run loot replace entity @s inventory.8 loot gm4_puzzle_block:inventory/completion/collectables_1
execute if score $collectables gm4_pb_completion matches 2.. run loot replace entity @s inventory.8 loot gm4_puzzle_block:inventory/completion/collectables_count

# toggles
function gm4_puzzle_block:technical/inventory/build/completion/toggles

data remove storage gm4_puzzle_block:temp CustomModelData
tag @s remove gm4_pb_changing_inv
