# fix a players inventory if they have changed it
# @s = player that altered their inventory
# at @s
advancement revoke @s only gm4_puzzle_block:technical/inventory_changed

# tag to not trigger advancement again
tag @s add gm4_pb_changing_inv

# check for button changing
execute if score $toggle.1 gm4_pb_completion matches 1.. unless data entity @s Inventory[{Slot:9b,id:"minecraft:light_gray_dye"}] run scoreboard players add $toggle.1 gm4_pb_completion 1
execute if score $toggle.2 gm4_pb_completion matches 1.. unless data entity @s Inventory[{Slot:10b,id:"minecraft:light_gray_dye"}] run scoreboard players add $toggle.2 gm4_pb_completion 1
execute if score $toggle.3 gm4_pb_completion matches 1.. unless data entity @s Inventory[{Slot:11b,id:"minecraft:light_gray_dye"}] run scoreboard players add $toggle.3 gm4_pb_completion 1
execute if score $toggle.4 gm4_pb_completion matches 1.. unless data entity @s Inventory[{Slot:12b,id:"minecraft:light_gray_dye"}] run scoreboard players add $toggle.4 gm4_pb_completion 1
execute if score $toggle.5 gm4_pb_completion matches 1.. unless data entity @s Inventory[{Slot:13b,id:"minecraft:light_gray_dye"}] run scoreboard players add $toggle.5 gm4_pb_completion 1
execute if score $toggle.6 gm4_pb_completion matches 1.. unless data entity @s[tag=gm4_pb_pusher] Inventory[{Slot:14b,id:"minecraft:light_gray_dye"}] run scoreboard players add $toggle.6 gm4_pb_completion 1
execute unless score $hint_toggling gm4_pb_data matches 1.. unless data entity @s Inventory[{Slot:100b,id:"minecraft:chainmail_boots"}] run scoreboard players add $toggle.hints gm4_pb_data 11

# check hint swapping
execute if score $toggle.hints gm4_pb_data matches 10.. run function gm4_puzzle_block:technical/hints/toggle

# clear inventory
clear @s

scoreboard players set $toggled gm4_pb_data 0
execute if score $toggle.1 gm4_pb_completion matches 2 run scoreboard players set $toggled gm4_pb_data 1
execute if score $toggle.2 gm4_pb_completion matches 2 run scoreboard players set $toggled gm4_pb_data 1
execute if score $toggle.3 gm4_pb_completion matches 2 run scoreboard players set $toggled gm4_pb_data 1
execute if score $toggle.4 gm4_pb_completion matches 2 run scoreboard players set $toggled gm4_pb_data 1
execute if score $toggle.5 gm4_pb_completion matches 2 run scoreboard players set $toggled gm4_pb_data 1
execute if score $toggle.6 gm4_pb_completion matches 2 run scoreboard players set $toggled gm4_pb_data 1
execute if score $toggle.1 gm4_pb_completion matches 4 run scoreboard players set $toggled gm4_pb_data 2
execute if score $toggle.2 gm4_pb_completion matches 4 run scoreboard players set $toggled gm4_pb_data 2
execute if score $toggle.3 gm4_pb_completion matches 4 run scoreboard players set $toggled gm4_pb_data 2
execute if score $toggle.4 gm4_pb_completion matches 4 run scoreboard players set $toggled gm4_pb_data 2
execute if score $toggle.5 gm4_pb_completion matches 4 run scoreboard players set $toggled gm4_pb_data 2
execute if score $toggle.6 gm4_pb_completion matches 4 run scoreboard players set $toggled gm4_pb_data 2

execute if score $toggle.1 gm4_pb_completion matches 2 run scoreboard players set $toggle.1 gm4_pb_completion 3
execute if score $toggle.2 gm4_pb_completion matches 2 run scoreboard players set $toggle.2 gm4_pb_completion 3
execute if score $toggle.1 gm4_pb_completion matches 4.. run scoreboard players set $toggle.1 gm4_pb_completion 1
execute if score $toggle.2 gm4_pb_completion matches 4.. run scoreboard players set $toggle.2 gm4_pb_completion 1

execute if score $toggle.3 gm4_pb_completion matches 2 run function gm4_puzzle_block:technical/toggles/winter/on
execute if score $toggle.4 gm4_pb_completion matches 2 run function gm4_puzzle_block:technical/toggles/summer/on
execute if score $toggle.5 gm4_pb_completion matches 2 run function gm4_puzzle_block:technical/toggles/end/on
execute if score $toggle.6 gm4_pb_completion matches 2 run function gm4_puzzle_block:technical/toggles/secrets/on
execute if score $toggle.3 gm4_pb_completion matches 4 run function gm4_puzzle_block:technical/toggles/winter/off
execute if score $toggle.4 gm4_pb_completion matches 4 run function gm4_puzzle_block:technical/toggles/summer/off
execute if score $toggle.5 gm4_pb_completion matches 4 run function gm4_puzzle_block:technical/toggles/end/off
execute if score $toggle.6 gm4_pb_completion matches 4 run function gm4_puzzle_block:technical/toggles/secrets/off

execute if score $toggled gm4_pb_data matches 1 at @s run playsound minecraft:block.lever.click player @s ~ ~ ~ 1 0.7
execute if score $toggled gm4_pb_data matches 2 at @s run playsound minecraft:block.lever.click player @s ~ ~ ~ 1 0.45

# get slot
execute store result score $slot gm4_pb_data run data get entity @s SelectedItemSlot
scoreboard players operation $slot gm4_pb_data %= #3 gm4_pb_data

# delete items in case they were thrown out
kill @e[type=item]

execute if entity @s[team=player] run function gm4_puzzle_block:technical/inventory/build/completion/base
execute if entity @s[team=player] run function gm4_puzzle_block:technical/inventory/build/buttons/base
execute if score $toggled gm4_pb_data matches 1.. as @a[team=player,tag=!gm4_pb_pusher] at @s run function gm4_puzzle_block:technical/inventory/build/completion/base

tag @s remove gm4_pb_changing_inv
