# check if pusher can push
# @s = pusher player
# at @s align xz positioned ~0.5 ~-0.06251 ~0.5
# run from technical/pusher/submain

# check if on pushable block and not hovering above half-height blocks
execute if predicate gm4_puzzle_block:puzzle_blocks/allow_push run scoreboard players set $pushing_allowed gm4_pb_data 1
# | Exceptions
# if riding something
execute on vehicle run scoreboard players set $pushing_allowed gm4_pb_data -1
# if in water (run even if pushing is not allowed)
execute unless score $pushing_allowed gm4_pb_data matches -1 at @s if block ~ ~ ~ #gm4_puzzle_block:water run scoreboard players set $pushing_allowed gm4_pb_data -1
# in the middle of a stair (run even if pushing is not allowed)
execute unless score $pushing_allowed gm4_pb_data matches -1 if block ~ ~ ~ #minecraft:stairs[half=bottom] unless block ~ ~-0.937 ~ #minecraft:stairs[half=bottom] unless block ~ ~0.5625 ~ #minecraft:stairs[half=bottom] run scoreboard players set $pushing_allowed gm4_pb_data -1
# in the middle of iron bars (run even if pushing is not allowed)
execute unless score $pushing_allowed gm4_pb_data matches -1 if block ~ ~ ~ iron_bars if block ~ ~-0.0001 ~ iron_bars run scoreboard players set $pushing_allowed gm4_pb_data -1
# inside an open trapdoor not on the ground (run even if pushing is not allowed)
execute unless score $pushing_allowed gm4_pb_data matches -1 if block ~ ~ ~ #minecraft:trapdoors[open=true] if block ~ ~-0.0001 ~ #minecraft:trapdoors[open=true] run scoreboard players set $pushing_allowed gm4_pb_data -1
# on or above a chain (run even if pushing is not allowed)
execute unless score $pushing_allowed gm4_pb_data matches -1 if block ~ ~-0.0001 ~ chain run scoreboard players set $pushing_allowed gm4_pb_data -1
# hovering above half-height
execute if score $pushing_allowed gm4_pb_data matches 1 positioned ~ ~-0.5 ~ if predicate gm4_puzzle_block:puzzle_blocks/half_height_check run scoreboard players set $pushing_allowed gm4_pb_data -1
# hovering above floor trapdoor
execute if score $pushing_allowed gm4_pb_data matches 1 if block ~ ~-0.18751 ~ #minecraft:trapdoors[half=bottom,open=false] run scoreboard players set $pushing_allowed gm4_pb_data -1
# on extended piston that isn't facing up
execute if score $pushing_allowed gm4_pb_data matches 1 positioned ~ ~-0.5 ~ if entity @e[type=item_display,tag=gm4_pb_piston.pushed,tag=!gm4_pb_piston.up,distance=..0.3] run scoreboard players set $pushing_allowed gm4_pb_data 0
# hovering above snow layer
execute if score $pushing_allowed gm4_pb_data matches 1 if block ~ ~ ~ snow[layers=1] if block ~ ~-0.0001 ~ snow run scoreboard players set $pushing_allowed gm4_pb_data -1
execute if score $pushing_allowed gm4_pb_data matches 1 if block ~ ~ ~ snow[layers=2] if block ~ ~-0.0625 ~ snow run scoreboard players set $pushing_allowed gm4_pb_data -1
execute if score $pushing_allowed gm4_pb_data matches 1 if block ~ ~ ~ snow[layers=3] if block ~ ~-0.1875 ~ snow run scoreboard players set $pushing_allowed gm4_pb_data -1
execute if score $pushing_allowed gm4_pb_data matches 1 if block ~ ~ ~ snow[layers=4] if block ~ ~-0.3125 ~ snow run scoreboard players set $pushing_allowed gm4_pb_data -1
execute if score $pushing_allowed gm4_pb_data matches 1 if block ~ ~ ~ snow[layers=5] if block ~ ~-0.4375 ~ snow run scoreboard players set $pushing_allowed gm4_pb_data -1
execute if score $pushing_allowed gm4_pb_data matches 1 if block ~ ~ ~ snow[layers=6] if block ~ ~-0.5625 ~ snow run scoreboard players set $pushing_allowed gm4_pb_data -1
execute if score $pushing_allowed gm4_pb_data matches 1 if block ~ ~ ~ snow[layers=7] if block ~ ~-0.6875 ~ snow run scoreboard players set $pushing_allowed gm4_pb_data -1
