# update stats
# @s = unspecified
# at unspecified
# run from technical/stats/clock

# convert to nbt
execute store result storage gm4_puzzle_block:stats stat.playtime_sec int 1 run scoreboard players get $playtime.seconds gm4_pb_puzzle_stats
execute store result storage gm4_puzzle_block:stats stat.playtime_min int 1 run scoreboard players get $playtime.minutes gm4_pb_puzzle_stats
execute store result storage gm4_puzzle_block:stats stat.playtime_hour int 1 run scoreboard players get $playtime.hours gm4_pb_puzzle_stats

data modify storage gm4_puzzle_block:stats stat.playtime set value []
execute if score $playtime.seconds gm4_pb_puzzle_stats matches ..9 run data modify storage gm4_puzzle_block:stats stat.playtime prepend value '[{"text":":0"},{"nbt":"stat.playtime_sec","storage":"gm4_puzzle_block:stats"}]'
execute if score $playtime.seconds gm4_pb_puzzle_stats matches 10.. run data modify storage gm4_puzzle_block:stats stat.playtime prepend value '[{"text":":"},{"nbt":"stat.playtime_sec","storage":"gm4_puzzle_block:stats"}]'
execute unless score $playtime.minutes gm4_pb_puzzle_stats matches 1.. unless score $playtime.hours gm4_pb_puzzle_stats matches 1.. run data modify storage gm4_puzzle_block:stats stat.playtime prepend value '{"text":"0"}'
execute unless score $playtime.minutes gm4_pb_puzzle_stats matches 1.. if score $playtime.hours gm4_pb_puzzle_stats matches 1.. run data modify storage gm4_puzzle_block:stats stat.playtime prepend value '{"text":":00"}'
execute if score $playtime.minutes gm4_pb_puzzle_stats matches 1..9 unless score $playtime.hours gm4_pb_puzzle_stats matches 1.. run data modify storage gm4_puzzle_block:stats stat.playtime prepend value '{"nbt":"stat.playtime_min","storage":"gm4_puzzle_block:stats"}'
execute if score $playtime.minutes gm4_pb_puzzle_stats matches 1..9 if score $playtime.hours gm4_pb_puzzle_stats matches 1.. run data modify storage gm4_puzzle_block:stats stat.playtime prepend value '[{"text":":0"},{"nbt":"stat.playtime_min","storage":"gm4_puzzle_block:stats"}]'
execute if score $playtime.minutes gm4_pb_puzzle_stats matches 10.. unless score $playtime.hours gm4_pb_puzzle_stats matches 1.. run data modify storage gm4_puzzle_block:stats stat.playtime prepend value '{"nbt":"stat.playtime_min","storage":"gm4_puzzle_block:stats"}'
execute if score $playtime.minutes gm4_pb_puzzle_stats matches 10.. if score $playtime.hours gm4_pb_puzzle_stats matches 1.. run data modify storage gm4_puzzle_block:stats stat.playtime prepend value '[{"text":":"},{"nbt":"stat.playtime_min","storage":"gm4_puzzle_block:stats"}]'
execute if score $playtime.hours gm4_pb_puzzle_stats matches 1.. run data modify storage gm4_puzzle_block:stats stat.playtime prepend value '{"nbt":"stat.playtime_hour","storage":"gm4_puzzle_block:stats"}'

# hints used is updated whenever a hint is used
execute store result storage gm4_puzzle_block:stats stat.puzzles_solved int 1 run scoreboard players get $puzzles_solved gm4_pb_puzzle_stats
execute store result storage gm4_puzzle_block:stats stat.blocks_pushed int 1 run scoreboard players get $blocks_pushed gm4_pb_puzzle_stats
execute store result storage gm4_puzzle_block:stats stat.resets_used int 1 run scoreboard players get $resets_used gm4_pb_puzzle_stats
execute store result storage gm4_puzzle_block:stats stat.undos_used int 1 run scoreboard players get $undos_used gm4_pb_puzzle_stats

# update stat box if it's on
tag @a[team=player] add gm4_pb_changing_inv
execute if score $toggle.5 gm4_pb_completion matches 3 as @a[team=player,tag=gm4_pb_pusher] run loot replace entity @s armor.head loot gm4_puzzle_block:inventory/stat_hat
execute if score $toggle.5 gm4_pb_completion matches 3 as @a[team=player,tag=!gm4_pb_pusher] run loot replace entity @s armor.head loot gm4_puzzle_block:inventory/spectator_stat_hat
tag @a[team=player] remove gm4_pb_changing_inv
