# create a new button
# @s = new button item_display
# at @s align xyz positioned ~.5 ~.5 ~.5
# run from dev/check_button

# set button facing depending on button
execute if block ~ ~ ~ #minecraft:buttons[facing=east] run data merge entity @s {view_range:0.625f,Tags:["gm4_pb_button","gm4_pb_goals"],Rotation:[-90F,0F],transformation:{left_rotation:[1f,0f,0f,1f],right_rotation:[1f,0f,0f,1f],translation:[0f,0f,0f],scale:[.25f,.25f,.25f]},item:{id:"minecraft:leather_horse_armor",Count:1b,tag:{CustomModelData:101,display:{color:9057325}}}}
execute if block ~ ~ ~ #minecraft:buttons[facing=north] run data merge entity @s {view_range:0.625f,Tags:["gm4_pb_button","gm4_pb_goals"],Rotation:[180F,0F],transformation:{left_rotation:[1f,0f,0f,1f],right_rotation:[1f,0f,0f,1f],translation:[0f,0f,0f],scale:[.25f,.25f,.25f]},item:{id:"minecraft:leather_horse_armor",Count:1b,tag:{CustomModelData:101,display:{color:9057325}}}}
execute if block ~ ~ ~ #minecraft:buttons[facing=south] run data merge entity @s {view_range:0.625f,Tags:["gm4_pb_button","gm4_pb_goals"],Rotation:[0F,0F],transformation:{left_rotation:[1f,0f,0f,1f],right_rotation:[1f,0f,0f,1f],translation:[0f,0f,0f],scale:[.25f,.25f,.25f]},item:{id:"minecraft:leather_horse_armor",Count:1b,tag:{CustomModelData:101,display:{color:9057325}}}}
execute if block ~ ~ ~ #minecraft:buttons[facing=west] run data merge entity @s {view_range:0.625f,Tags:["gm4_pb_button","gm4_pb_goals"],Rotation:[90F,0F],transformation:{left_rotation:[1f,0f,0f,1f],right_rotation:[1f,0f,0f,1f],translation:[0f,0f,0f],scale:[.25f,.25f,.25f]},item:{id:"minecraft:leather_horse_armor",Count:1b,tag:{CustomModelData:101,display:{color:9057325}}}}
execute if block ~ ~ ~ #minecraft:buttons[face=ceiling] run data merge entity @s {view_range:0.625f,Tags:["gm4_pb_button","gm4_pb_goals"],Rotation:[0F,90F],transformation:{left_rotation:[1f,0f,0f,1f],right_rotation:[1f,0f,0f,1f],translation:[0f,0f,0f],scale:[.25f,.25f,.25f]},item:{id:"minecraft:leather_horse_armor",Count:1b,tag:{CustomModelData:101,display:{color:9057325}}}}
execute if block ~ ~ ~ #minecraft:buttons[face=floor] run data merge entity @s {view_range:0.625f,Tags:["gm4_pb_button","gm4_pb_goals"],Rotation:[0F,-90F],transformation:{left_rotation:[1f,0f,0f,1f],right_rotation:[1f,0f,0f,1f],translation:[0f,0f,0f],scale:[.25f,.25f,.25f]},item:{id:"minecraft:leather_horse_armor",Count:1b,tag:{CustomModelData:101,display:{color:9057325}}}}

# replace block
setblock ~ ~ ~ air
execute at @s run fill ~ ~-50 ~ ~ ~-50 ~ red_concrete replace air
execute at @s run fill ~ ~-55 ~ ~ ~-55 ~ redstone_block replace air

tellraw @a[gamemode=creative,distance=..8] {"text":"click to change button type","color":"yellow","clickEvent":{"action":"suggest_command","value":"/data modify entity @e[type=minecraft:item_display,tag=gm4_pb_button,distance=..5,limit=1,sort=nearest] item.tag.CustomModelData set value 101-107"}}
tellraw @a[gamemode=creative,distance=..8] {"text":"click to change button color","color":"yellow","clickEvent":{"action":"suggest_command","value":"/data modify entity @e[type=minecraft:item_display,tag=gm4_pb_button,distance=..5,limit=1,sort=nearest] item.tag.display.color set value X"}}
tellraw @a[gamemode=creative,distance=..8] {"text":"click to make button hidden","color":"yellow","clickEvent":{"action":"suggest_command","value":"/execute as @e[type=minecraft:item_display,tag=gm4_pb_button,distance=..5,limit=1,sort=nearest] run function gm4_puzzle_block:dev/make_button_hidden"}}

scoreboard players operation @s gm4_pb_id = $id gm4_pb_id
