# create a new magnet
# @s = new magnet slime
# at @s align xyz positioned ~.5 ~-.01 ~.5
# run from dev/check_magnet

# mark magnet facing in score
execute if block ~ ~.5 ~ #minecraft:buttons[facing=west] run scoreboard players set @s gm4_pb_data 4
execute unless score @s gm4_pb_data matches 1.. if block ~ ~.5 ~ #minecraft:buttons[facing=south] run scoreboard players set @s gm4_pb_data 3
execute unless score @s gm4_pb_data matches 1.. if block ~ ~.5 ~ #minecraft:buttons[facing=north] run scoreboard players set @s gm4_pb_data 2
execute unless score @s gm4_pb_data matches 1.. run scoreboard players set @s gm4_pb_data 1

# set slime data
data merge entity @s {Tags:["gm4_pb_magnet"],Silent:1b,PersistenceRequired:1b,NoAI:1b,Size:1,Invulnerable:1b,Health:10f,active_effects:[{id:"minecraft:invisibility",amplifier:0b,duration:-1,show_particles:0b},{id:"minecraft:resistance",amplifier:9b,duration:-1,show_particles:0b}],ArmorItems:[{},{},{},{id:"minecraft:command_block",Count:1b}]}
execute if score @s gm4_pb_data matches 1 run data modify entity @s Rotation set value [-90F,0F]
execute if score @s gm4_pb_data matches 2 run data modify entity @s Rotation set value [180F,0F]
execute if score @s gm4_pb_data matches 3 run data modify entity @s Rotation set value [0F,0F]
execute if score @s gm4_pb_data matches 4 run data modify entity @s Rotation set value [90F,0F]

# set block display type 
execute if score @s gm4_pb_data matches 1 run setblock ~ ~.5 ~ grindstone[face=wall,facing=east]
execute if score @s gm4_pb_data matches 2 run setblock ~ ~.5 ~ grindstone[face=wall,facing=north]
execute if score @s gm4_pb_data matches 3 run setblock ~ ~.5 ~ grindstone[face=wall,facing=south]
execute if score @s gm4_pb_data matches 4 run setblock ~ ~.5 ~ grindstone[face=wall,facing=west]

# puzzle id
scoreboard players operation @s gm4_pb_id = $id gm4_pb_id

# give id for beams
execute store result score @s gm4_pb_beam_id run scoreboard players add $beam_id_next gm4_pb_beam_id 1

# allow swapping of magnet state
execute at @s run function gm4_puzzle_block:mechanic/magnet/pull/set
tellraw @a[gamemode=creative,distance=..8] {"text":"click to set magnet to pull","color":"yellow","clickEvent":{"action":"suggest_command","value":"/execute as @e[tag=gm4_pb_magnet,distance=..5,limit=1,sort=nearest] at @s run function gm4_puzzle_block:mechanic/magnet/pull/set"}}
tellraw @a[gamemode=creative,distance=..8] {"text":"click to set magnet to push","color":"yellow","clickEvent":{"action":"suggest_command","value":"/execute as @e[tag=gm4_pb_magnet,distance=..5,limit=1,sort=nearest] at @s run function gm4_puzzle_block:mechanic/magnet/push/set"}}
tellraw @a[gamemode=creative,distance=..8] {"text":"click to set magnet to swappable","color":"yellow","clickEvent":{"action":"suggest_command","value":"/tag @e[tag=gm4_pb_magnet,distance=..5,limit=1,sort=nearest] add gm4_pb_magnet.swappable.pullORpush"}}
