# trigger pushing for first player that sneaks at the block
# @s = player
# at @s
# run from advancement map_trigger/intro/first_push

# set player data
tag @s add gm4_pb_pusher
scoreboard players set $reset_tick gm4_pb_data 0

scoreboard players set $intro_stage gm4_pb_data 2

# update inventory
tag @s add gm4_pb_changing_inv
execute store result score $slot gm4_pb_data run data get entity @s SelectedItemSlot
scoreboard players operation $slot gm4_pb_data %= #3 gm4_pb_data
playsound minecraft:entity.item.pickup player @s ~ ~ ~ 2 1
item replace entity @s hotbar.7 with air
execute unless score $slot gm4_pb_data matches 2 run loot replace entity @s hotbar.7 loot gm4_puzzle_block:inventory/buttons/view/unselected
execute if score $slot gm4_pb_data matches 2 run loot replace entity @s hotbar.7 loot gm4_puzzle_block:inventory/buttons/view/selected
function gm4_puzzle_block:technical/inventory/build/buttons/base
execute as @a[tag=!gm4_pb_pusher] run function gm4_puzzle_block:technical/player/pusher_remove
tag @s remove gm4_pb_changing_inv

# free up the barrier
setblock 961 106 1093 air

# spawn text
summon text_display 1000 117.475 1108.0 {line_width:300,Rotation:[-180F,0F],Tags:["gm4_pb_tutorial_text"],brightness:{sky:15,block:15},transformation:{left_rotation:[0f,0f,0f,1f],right_rotation:[0f,0f,0f,1f],translation:[0f,0f,0f],scale:[1f,1f,1f]},text:'[{"translate":"gm4_pb.intro.1","fallback":"Good luck out there! Remember to\\n"},{"translate":"gm4_pb.intro.2","fallback":"look around for secrets!"}]',background:1310720}

# grant push advancement
function gm4_puzzle_block:technical/advancements/push

# remove title screen
kill @e[tag=gm4_pb_title_screen]
