# lock selected buttons and plugs
# @s = button or plug
# at command block running this
# run from command blocks in world

# lock button (add 50 to CMD) 
execute store result score $cmd gm4_pb_data run data get entity @s item.tag.CustomModelData
execute store result entity @s[tag=!gm4_pb_goals.locked,tag=!gm4_pb_button.hidden] item.tag.CustomModelData int 1 run scoreboard players add $cmd gm4_pb_data 50

# play level completion sound and redo the inventory
execute unless score $puzzle_solved gm4_pb_sound_played matches 1 run function gm4_puzzle_block:mechanic/button/lock_effect
tag @s add gm4_pb_goals.locked

# if button was not pressed press it
execute if entity @s[tag=gm4_pb_button,tag=!gm4_pb_button.pressed] run function gm4_puzzle_block:mechanic/button/press_down

# set activated plugs/lamps to fullbright
data modify entity @s[tag=!gm4_pb_button] brightness set value {sky:15,block:15} 

# forceload
forceload add ~ ~

# add tag if button is pressed
execute at @s if entity @e[type=marker,tag=gm4_pb_block,distance=..0.1] run tag @s add gm4_pb_button.particles
