# push piston head out
# @s = piston item_display
# at @s
# run from mechanic/piston/push_check
# run from mechanic/undo/restore/piston

tag @s add gm4_pb_piston.pushed
scoreboard players set @s gm4_pb_piston_blocked 0

# replace block being pushed into
execute if block ~ ~ ~ #gm4_puzzle_block:allow_pushing_into[waterlogged=true] run tag @s add gm4_pb_puzzle_waterlogged
execute if block ~ ~ ~ #gm4_puzzle_block:requires_replacement run function gm4_puzzle_block:mechanic/move/store_block

execute if entity @s[tag=gm4_pb_puzzle_waterlogged] run setblock ~ ~ ~ dark_oak_leaves[persistent=false,waterlogged=true]
execute if entity @s[tag=!gm4_pb_puzzle_waterlogged] run setblock ~ ~ ~ dark_oak_leaves[persistent=false]

# magnet beams
execute if entity @e[type=item_display,tag=gm4_pb_magnet.beam,distance=..0.3] run tag @s add gm4_pb_puzzle_magnet_block
execute if entity @s[tag=gm4_pb_puzzle_magnet_block] as @e[type=slime,tag=gm4_pb_magnet,predicate=gm4_puzzle_block:puzzle_blocks/magnet_in_range] at @s run function gm4_puzzle_block:mechanic/magnet/recalculate

# movement and play sound
data merge entity @s {start_interpolation:-1,interpolation_duration:4,transformation:{translation:[0f,0f,0f]}}
execute unless score $piston_push gm4_pb_sound_played matches 1 store success score $piston_push gm4_pb_sound_played run playsound block.piston.extend block @a ~ ~ ~ 1 0.6

# move players
scoreboard players operation $push_direction gm4_pb_data = @s gm4_pb_data
execute align xyz as @a[gamemode=adventure,dx=0,dy=0,dz=0] at @s run function gm4_puzzle_block:mechanic/piston/push_player

data modify entity @s item.tag.gm4_puzzle_block.current_state set value 1
